import { world, system } from '@minecraft/server';

world.afterEvents.entityHitEntity.subscribe(e=>{
    try{
      const attacker=e.damagingEntity;
      const attackerId=attacker.typeId;
      const victim=e.hitEntity;
      const victimId=victim.typeId;
      if(attackerId==="mutant:mutant_creeper"){
        if(victimId==="minecraft:player"){
            const viewDirection = attacker.getViewDirection();
          victim.applyKnockback(15 * viewDirection.x,15 * viewDirection.z,0.75,0.4);
        }
        else{
            const viewDirection = attacker.getViewDirection();
            victim.applyImpulse({ x: 0.5 * viewDirection.x, y: 0.25, z: 0.5 * viewDirection.z });
        }
      }
    }catch(error){}finally{}
  });
  world.afterEvents.entityHitEntity.subscribe(e=>{
    try{
      const attacker=e.damagingEntity;
      const attackerId=attacker.typeId;
      const victim=e.hitEntity;
      const victimId=victim.typeId;
      if(attackerId==="mutant:mutant_wither_skeleton"){
        if(victimId==="minecraft:player"){
            const viewDirection = attacker.getViewDirection();
          victim.applyKnockback(15 * viewDirection.x,15 * viewDirection.z,2,0.25);
        }
        else{
            const viewDirection = attacker.getViewDirection();
            victim.applyImpulse({ x: 1.5 * viewDirection.x, y: 0.075, z: 1.5 * viewDirection.z });
        }
      }
    }catch(error){}finally{}
  });
  world.afterEvents.entityHitEntity.subscribe(e=>{
    try{
      const attacker=e.damagingEntity;
      const attackerId=attacker.typeId;
      const victim=e.hitEntity;
      const victimId=victim.typeId;
      if(attackerId==="mutant:mutant_villager"){
        if(victimId==="minecraft:player"){
            const viewDirection = attacker.getViewDirection();
          victim.applyKnockback(10 * viewDirection.x,10 * viewDirection.z,1.25,0.25);
        }
        else{
            const viewDirection = attacker.getViewDirection();
            victim.applyImpulse({ x: 0.5 * viewDirection.x, y: 0.075, z: 0.5 * viewDirection.z });
        }
      }
    }catch(error){}finally{}
  });

world.beforeEvents.worldInitialize.subscribe(e => {
    e.itemComponentRegistry.registerCustomComponent("mutant_script:shard_durability", {onHitEntity: hit_event, onUse: use_creepershard_event, onBeforeDurabilityDamage: durability_damage_event});
});

function durability_damage_event(e) {
    // Cancel vanilla damage event
    e.durabilityDamage = 0;
}


function hit_event(e) {
    // Get data from event
    const source = e.attackingEntity;
    const itemStack = e.itemStack;

    // Get Damage
    const durabilityComponent = itemStack.getComponent('durability');
    const damage = durabilityComponent.damage;
    
    if (damage != 0) {
        durabilityComponent.damage = Math.max(damage - 1, 0);
        source.getComponent("equippable").setEquipment("Mainhand", itemStack);
       
    }
    else if (damage == 0) {
        source.sendMessage("This Creeper Shard is fully charged")
    }
  

  
}


function use_creepershard_event(e) {
    // Get data from event
    const player = e.source;
    const itemStack = e.itemStack;
    
    // Get Damage
    const durabilityComponent = itemStack.getComponent('durability');
    const damage = durabilityComponent.damage;
    
    // Take different actions depending on damage level
    if (damage == 0) {
        player.runCommandAsync('replaceitem entity @s slot.weapon.mainhand 1 mutant:creeper_shard 1 35');
        const explosionLocation = {x: player.location.x, y: player.location.y + 1.75, z: player.location.z};
        player.addEffect("resistance", 1, {amplifier: 10});
        player.addEffect("slow_falling", 1, {amplifier: 10});
        player.dimension.createExplosion(explosionLocation, 7, {breaksBlocks: true});
       
    }
    else if (damage >= 30) {
        player.sendMessage("This Creeper Shard must be charged")
    }
    else if (damage >= 18) {
        player.sendMessage("This Creeper Shard is 25%% charged")
    }
    else if (damage >= 11) {
        player.sendMessage("This Creeper Shard is 50%% charged")
    }
    else if (damage >= 4) {
        player.sendMessage("This Creeper Shard is 75%% charged")
    }
    else if (damage >= 1) {
        player.sendMessage("This Creeper Shard is almost fully charged")
    }
}
world.beforeEvents.worldInitialize.subscribe(e => {
    e.itemComponentRegistry.registerCustomComponent("mutant_script:endersoul_teleport", { onUse: use_endersoul_teleport_event});
});
function use_endersoul_teleport_event(e) {
    const itemStack = e.itemStack;
    
    // Get Damage
    const durabilityComponent = itemStack.getComponent('durability');
    const damage = durabilityComponent.damage;
    
    const entity = e.source;
    if (entity.isSneaking && damage != 240) {
      
        const projectile = "mutant:endersoul_pearl";
        


        const arrow = entity.dimension.spawnEntity(projectile, entity.getHeadLocation());
        const projComp = arrow.getComponent("projectile");
        projComp.owner = entity;

        // Increase projectile speed by multiplying view direction
        const viewDirection = entity.getViewDirection();
        const speedMultiplier = 90;  // Increase this value to make the projectile faster

        const increasedSpeed = {
            x: viewDirection.x * speedMultiplier,
            y: viewDirection.y * speedMultiplier,
            z: viewDirection.z * speedMultiplier
        };

        projComp.shoot(increasedSpeed);
        entity.addEffect("resistance", 2, {amplifier: 50});
        durabilityComponent.damage = Math.max(damage + 1, 0);
        entity.getComponent("equippable").setEquipment("Mainhand", itemStack);
    }
   else if (entity.isSneaking == false && damage != 240) {
      
        
    const projectile = "mutant:endersoul_block_catcher<endersoul_hand_throw>";


        const arrow = entity.dimension.spawnEntity(projectile, entity.getHeadLocation());
        const projComp = arrow.getComponent("projectile");

        // Increase projectile speed by multiplying view direction
        const viewDirection = entity.getViewDirection();
        const speedMultiplier = 3;  // Increase this value to make the projectile faster

        const increasedSpeed = {
            x: viewDirection.x * speedMultiplier,
            y: viewDirection.y * speedMultiplier,
            z: viewDirection.z * speedMultiplier
        };

        projComp.shoot(increasedSpeed);
        durabilityComponent.damage = Math.max(damage + 1, 0);
        entity.getComponent("equippable").setEquipment("Mainhand", itemStack);
    }
    else if (entity.isSneaking && damage == 240) {
      
        const projectile = "mutant:endersoul_pearl";
        


        const arrow = entity.dimension.spawnEntity(projectile, entity.getHeadLocation());
        const projComp = arrow.getComponent("projectile");
        projComp.owner = entity;

        // Increase projectile speed by multiplying view direction
        const viewDirection = entity.getViewDirection();
        const speedMultiplier = 90;  // Increase this value to make the projectile faster

        const increasedSpeed = {
            x: viewDirection.x * speedMultiplier,
            y: viewDirection.y * speedMultiplier,
            z: viewDirection.z * speedMultiplier
        };

        projComp.shoot(increasedSpeed);
        entity.addEffect("resistance", 2, {amplifier: 50});
        entity.runCommandAsync('clear @s mutant:endersoul_hand 240 1');
        entity.runCommandAsync('playsound random.break');
        entity.getComponent("equippable").setEquipment("Mainhand", itemStack);
    }
   else if (entity.isSneaking == false && damage == 240) {
      
        
    const projectile = "mutant:endersoul_block_catcher<endersoul_hand_throw>";


        const arrow = entity.dimension.spawnEntity(projectile, entity.getHeadLocation());
        const projComp = arrow.getComponent("projectile");

        // Increase projectile speed by multiplying view direction
        const viewDirection = entity.getViewDirection();
        const speedMultiplier = 3;  // Increase this value to make the projectile faster

        const increasedSpeed = {
            x: viewDirection.x * speedMultiplier,
            y: viewDirection.y * speedMultiplier,
            z: viewDirection.z * speedMultiplier
        };

        projComp.shoot(increasedSpeed);
        entity.runCommandAsync('clear @s mutant:endersoul_hand 240 1');
        entity.runCommandAsync('playsound random.break');
        entity.getComponent("equippable").setEquipment("Mainhand", itemStack);
    }
}